
<?php

  require_once "PieceQuantik.php";
  class ArrayPieceQuantik
{
    protected  $piecesQuantiks ; //tableau de piece quantique
    protected  $taille ; //la taille du tableau

    //elle construit un tableau vide
    public function __construct() {
        $this->piecesQuantiks = array();
        $this->taille =0;
    }

    //afficher les éléments du tableau
    public function __toString() : string {
        $res = "( ";
        for($i = 0; $i < $this->taille; $i++){ //=sizeof($this->piecesQuantiks) ou boocle foreach
            $res .=$this->piecesQuantiks[$i].", ";
        }
        $res .= ")";
        return $res;
    }

    //retourne la piece à l'indice pos du tableau
    public function getPieceQuantik(int $pos):PieceQuantik {
        return $this->piecesQuantiks[$pos];
    }

    //remplacer la piece à l'indice pos avec piece 
    public function setPieceQuantik(int $pos , PieceQuantik $piece){
        $this->piecesQuantiks[$pos] = $piece;
    }

    //ajouter une piece dans le tableau
    public function addPieceQuantik(PieceQuantik $piece){
        $this->piecesQuantiks[$this->taille++] = $piece;
    }

    //supprimer la piece à la position pos du tableau
    public function removePieceQuantik(int $pos){
        array_splice($this->piecesQuantiks,$pos,1);
        $this->taille--;
    }
    
    //retourne la taille du tableau
    public function getTaille() {
        return $this->taille;
    }

    //modifie la taille du tableau
    public function setTaille(int $taille) {
        $this->taille=$taille;
    }

    //crée un tableau contenant des pieces noires
    public static function initPiecesNoires(): ArrayPieceQuantik{
          $k = new ArrayPieceQuantik();
          $k->addPieceQuantik(PieceQuantik::initBlackCube());
          $k->addPieceQuantik(PieceQuantik::initBlackCube());
          $k->addPieceQuantik(PieceQuantik::initBlackCone());
          $k->addPieceQuantik(PieceQuantik::initBlackCone());
          $k->addPieceQuantik(PieceQuantik::initBlackCylindre());
          $k->addPieceQuantik(PieceQuantik::initBlackCylindre());
          $k->addPieceQuantik(PieceQuantik::initBlackSphere());
          $k->addPieceQuantik(PieceQuantik::initBlackSphere());
          return $k;
      }
      //crée un tableau contenant des pieces blanches
      public static function initPiecesBlanches(): ArrayPieceQuantik{
          $k = new ArrayPieceQuantik();
          $k->addPieceQuantik(PieceQuantik::initWhiteCube());
          $k->addPieceQuantik(PieceQuantik::initWhiteCube());
          $k->addPieceQuantik(PieceQuantik::initWhiteCone());
          $k->addPieceQuantik(PieceQuantik::initWhiteCone());
          $k->addPieceQuantik(PieceQuantik::initWhiteCylindre());
          $k->addPieceQuantik(PieceQuantik::initWhiteCylindre());
          $k->addPieceQuantik(PieceQuantik::initWhiteSphere());
          $k->addPieceQuantik(PieceQuantik::initWhiteSphere());
          return $k;
      }
}

?>