<?php

class PieceQuantik
{
    const WHITE = 0; //couleur blanche
    const BLACK = 1; // couleur noire
    const VOID = 0; //piece vide
    const CUBE = 1; //piece en forme de cube
    const CONE = 2; //piece en forme de cone
    const CYLINDRE = 3; //piece en forme de cylindre 
    const SPHERE = 4; //piece en forme de sphere
    protected $forme; //la forme d'une piece
    protected $couleur; //la couleur d'une piece

    //constuit une piece en lui donnant une forme et une couleur
    private function __construct($forme, $couleur) {
        $this->forme = $forme;
        $this->couleur = $couleur;
    }

    //recuperer la forme d'une piece
    public function getForme():int {
        return $this->forme;
    }

    //recuperer la couleur d'une piece
    public function getCouleur():int {
        return $this->couleur;
    }

    //afficher une piece, (sa forme et sa couleur)
    public function __toString() : string {
        $s="(";
        if($this->forme == 0){$s.=" )";return $s;}
        elseif($this->forme == 1){$s.="Cu";}
        elseif ($this->forme == 2) {$s.="Co";}
        elseif ($this->forme == 3) {$s.="Cy";}
        else {$s.="Sp";}
        $s.=":";
        if($this->couleur == 1){
            $s.="B";
        }else{
            $s .= "W";}
            $s .= ")";
        return $s;
    }

    //cette methode permet de créer une piece vide, sans forme spécifique avec une couleur vide
    public static function initVoid(): PieceQuantik{
        return new PieceQuantik(self::VOID,self::VOID);
    }

    //cette methode permet de créer une piece blanche en forme de cube 
    public static function initWhiteCube(): PieceQuantik{
        return new PieceQuantik(self::CUBE,self::WHITE);
    }

    //cette methode permet de créer une piece noire en forme de cube 
    public static function initBlackCube(): PieceQuantik{
        return new PieceQuantik(self::CUBE,self::BLACK);
    }

    //cette methode permet de créer une piece blanche en forme de cone 
    public static function initWhiteCone(): PieceQuantik{
        return new PieceQuantik(self::CONE,self::WHITE);
    }

    //cette methode permet de créer une piece noire en forme de cone 
    public static function initBlackCone(): PieceQuantik{
        return new PieceQuantik(self::CONE,self::BLACK);
    }

    //cette methode permet de créer une piece blanche en forme de cylindre 
    public static function initWhiteCylindre(): PieceQuantik{
        return new PieceQuantik(self::CYLINDRE,self::WHITE);
    }

    //cette methode permet de créer une piece noire en forme de cylindre 
    public static function initBlackCylindre(): PieceQuantik{
        return new PieceQuantik(self::CYLINDRE,self::BLACK);
    }

    //cette methode permet de créer une piece blanche en forme de sphere 
    public static function initWhiteSphere(): PieceQuantik{
        return new PieceQuantik(self::SPHERE,self::WHITE);
    }

    //cette methode permet de créer une piece noire en forme de sphere 
    public static function initBlackSphere(): PieceQuantik{
        return new  PieceQuantik(self::SPHERE,self::BLACK);
    }
}

?>